include graphics.e

global function pol_2_rec(sequence pol)
-- Converts polar coor. to rec. coor.
-- pol = {intensity, angle}
	pol[2] = 6.2818 * (pol[2] / 360)
	return {pol[1] * cos(pol[2]) + 319,
			pol[1] * sin(pol[2]) + 239}
end function

global function rotate(sequence obj, atom amount)
-- Rotates object <obj> by <amount>
	for t = 1 to length(obj) do
		obj[t][2] = obj[t][2] + amount
	end for
	
	return obj
end function

global function size(sequence obj, atom amount)
-- Shrinks or enlarges object <obj> by <amount>.
	for t = 1 to length(obj) do
		obj[t][1] = obj[t][1] + amount
	end for
	
	return obj
end function

global procedure pol_line(atom color, sequence pol)
-- Draws a line using polar coordinates at <pol> colored <color>.
	pol = append(pol, pol[1])
	for t = 1 to length(pol) do
		pol[t] = pol_2_rec(pol[t])
	end for
	draw_line(color, pol)
end procedure

global function jellow(atom color, sequence obj)
-- Makes colors <obj> <color> and makes it look like jellow.
	atom t1, t2
	
	pol_line(0, obj)
	t1 = rand(length(obj))
	t2 = rand(10) - 5
	obj[t1][2] = obj[t1][2] + t2
	pol_line(color, obj)
	
	return obj
end function

global procedure spiral(atom color, atom loops, atom step)
-- Draws a spiral <loops> loops with <step> in between them colored <color>.
	sequence buf_1
	pixel(color, pol_2_rec({0, 0}))
	buf_1 = {0, 0}
	for t = 1 to 360 * loops do
		draw_line(color, {pol_2_rec(buf_1), pol_2_rec({t * step, t})})
		buf_1 = {t * step, t}
	end for
end procedure
